﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices.Sensors;

namespace Practice_17
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            InitializeComponent();
            Accelerometer acc = new Accelerometer();
            acc.ReadingChanged += OnAccelerometerReadingChanged;

            try
            {
                acc.Start();
            }
            catch (Exception exc)
            {
                txtblk.Text = exc.Message;
            }
        }

        delegate void SetTextBlockTextDelegate(TextBlock txtblk, string text);

        void SetTextBlockText(TextBlock txtblk, string text)
        {
            txtblk.Text = text;
        }

        void OnAccelerometerReadingChanged(object sender, AccelerometerReadingEventArgs args)
        {
            string str = String.Format("X = {0:F2}\n" +
            "Y = {1:F2}\n" +
            "Z = {2:F2}\n\n" +
            "Magnitude = {3:F2}\n\n" +
            "{4}",
            args.X, args.Y, args.Z,
            Math.Sqrt(args.X * args.X + args.Y * args.Y +
            args.Z * args.Z),
            args.Timestamp);

            if (txtblk.CheckAccess())
            {
                txtblk.Text = str;
            }
            else
            {
                txtblk.Dispatcher.BeginInvoke(delegate()
                {
                    txtblk.Text = str;
                });
            }
        }
    }

}